<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>List Users</title>
</head>

<body>
    <div class="container">
        <h2 class="text-center my-4">Danh sách người dùng đăng ký</h2>
        <table id="table-users" class="table table-striped table-bordered table-hover">
            <thead>
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Firstname</th>
                    <th scope="col">Lastname</th>
                    <th scope="col">Country</th>
                    <th scope="col">Subject</th>
                    <th scope="col">Customer Type</th>
                    <th scope="col">Register Status</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>
<script>
    $(document).ready(function () {
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREADYSTATE_FINISHED_RESPONSEREADY = 4;
        const gREQUEST_STATUS_OK = 200;

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
            onPageLoading();
            $(document).on("click",".btn-edit",function(){
                console.log("Click nút sửa!");
                var vId = $(this).data("id");
                console.log(`Ta có id là: ${vId}`);
            })
            $(document).on("click",".btn-delete",function(){
                console.log("Click nút xóa!");
                var vId = $(this).data("id");
                console.log(`Ta có id là: ${vId}`);
            })
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
       
        /*
        * hàm load user data click dùng Ajax
        */
            function onPageLoading() {
                "use strict";
                $.ajax({
                    url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
                    type: 'GET',
                    dataType: 'json', // added data type
                    success: function (res) {
                        console.log(res);
                        fillDataToTable(res);
                    },
                    error: function (ajaxContext) {
                        alert(ajaxContext.responseText)
                    }
                });
            }       

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
            function fillDataToTable(paramData){
                "use strict";
                for(var bI = 0; bI < paramData.length; bI++){
                    var vRow = `<tr>
                                    <td>${paramData[bI].id}</td>
                                    <td>${paramData[bI].firstname}</td>
                                    <td>${paramData[bI].lastname}</td>
                                    <td>${paramData[bI].country}</td>
                                    <td>${paramData[bI].subject}</td>
                                    <td>${paramData[bI].customerType}</td>
                                    <td>${paramData[bI].registerStatus}</td>
                                    <td><button class="btn btn-primary btn-edit" data-id="${paramData[bI].id}">Edit</button> <button data-id="${paramData[bI].id}" class="btn btn-danger btn-delete">Delete</button></td>                                
                                </tr>`;
                    $("#table-users tbody").append(vRow);
                }
            }
    })

</script>

</html>